#include <windows.h>
#include <stdint.h>
#include <imm.h>
#include <stdio.h>
#include "cannaapi.h"
#include "apisup.h"
#include "ut.h"
#include "lib.h"

#define AT_OK		0
#define AT_FAIL		-1
#define AT_NOTATOK	-2
#define ATDICFILESETNICKNAME_MAX	81
#define	ATCHECKVERSION			0
#define	ATCHECKVERSION_ORGREATER	1

HINSTANCE AtDll;

bool at_get_dic_list(CannaHeader *ch,int fd);
bool at_get_dir_list(CannaHeader *ch,int fd);

int WINAPI AT_GetDicFileSetNickname(HIMC imc,int fno,uint16_t* str)
{
    static typeof(AT_GetDicFileSetNickname)* funcp;
    if(funcp == NULL)
	funcp = (typeof(funcp))GetProcAddress(AtDll,__FUNCTION__);
    return funcp(imc,fno,str);
}

int WINAPI AT_GetDefaultDicNo(HIMC imc)
{
    static typeof(AT_GetDefaultDicNo)* funcp;
    if(funcp == NULL)
	funcp = (typeof(funcp))GetProcAddress(AtDll,__FUNCTION__);
    return funcp(imc);
}

int WINAPI AT_SetDefaultDicNo(HIMC imc,int n)
{
    static typeof(AT_SetDefaultDicNo)* funcp;
    if(funcp == NULL)
	funcp = (typeof(funcp))GetProcAddress(AtDll,__FUNCTION__);
    return funcp(imc,n);
}

BOOL WINAPI AT_IsATOKDefaultIME(int ver,int mode)
{
    static typeof(AT_IsATOKDefaultIME)* funcp;
    if(funcp == NULL)
	funcp = (typeof(funcp))GetProcAddress(AtDll,__FUNCTION__);
    return funcp(ver,mode);
}

bool AtInit(WMCANNAPROTO* tab[])
{
    struct{
	int mj,mn;
	WMCANNAPROTO func;
    } sp[]={
	{0x06,0,at_get_dic_list},
	{0x07,0,at_get_dir_list},
	{0,0,NULL}
    },*p;

    AtDll = LoadLibrary("atoklib.dll");
    if(AtDll == NULL){
	VERBOSE(DBG("fail LoadLibray() atoklib.dll\n"));
	return false;
    }
    if(!AT_IsATOKDefaultIME(12,ATCHECKVERSION_ORGREATER)){
	VERBOSE(DBG("atok is not default ime.\n"));
	return false;
    }

    for(p=sp; p->func!=NULL; ++p)
	tab[p->mn][p->mj] = p->func;
    VERBOSE(DBG("done.\n"));
    return true;
}

/* 򤵤Ƥ뼭񥻥åȤ֤̾ */
//06
bool at_get_dic_list(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t bufsize;
    int dn,len;
    uint16_t u[ATDICFILESETNICKNAME_MAX];
    char mbbuf[ATDICFILESETNICKNAME_MAX*2],*mb=NULL;
    CannaContext_t *cx;

    Req3(ch->Data.adr,&cxn,&bufsize);
    VERBOSE(DBG("context %hd, buffer size %hd\n",cxn,bufsize));

    if((cx = ValidContext(cxn,__FUNCTION__))!=NULL || bufsize>=ATDICFILESETNICKNAME_MAX){
	HIMC imc = ImmGetContext(cx->Win);
	dn=AT_SetDefaultDicNo(imc,0);
	if((dn = AT_GetDefaultDicNo(imc)) >= 0){
	    mb = mbbuf;
	    AT_GetDicFileSetNickname(imc,dn,u);
	    WcToMb(u,-1,mb,-1);
	    ConvCode(mb,mb,Sj2Ej);
	    len = strlen(mb)+1;
	    mb[len++] = 0; //ꥹȤνλޡlenϥޡޤ᤿Хȿˤʤ롣
	    VERBOSE(DBG("dic number=%d,name='%s'\n",dn,mb));
	}
	ImmReleaseContext(cx->Win,imc);
    }
    return Reply6(ch->Major,ch->Minor,(mb!=NULL?1:-1),mb,len);
}

/* ͭʼ񥻥å̾ꥹȤˤ */
//07
bool at_get_dir_list(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t bufsize;
    int n,len;
    Array lst;
    bool st;
    CannaContext_t *cx;

    Req3(ch->Data.adr,&cxn,&bufsize);
    VERBOSE(DBG("context %hd, buffer size %hd\n",cxn,bufsize));

    n = 0;
    ArNew(&lst,1,NULL);
    if((cx = ValidContext(cxn,__FUNCTION__))!=NULL){
	uint16_t u[ATDICFILESETNICKNAME_MAX];
	char mb[ATDICFILESETNICKNAME_MAX*2];
	HIMC imc = ImmGetContext(cx->Win);

	VERBOSE(DBGP("dics:"));
	while(AT_GetDicFileSetNickname(imc,n,u) == AT_OK){
	    WcToMb(u,-1,mb,-1);
	    ConvCode(mb,mb,Sj2Ej);
	    ArAddN(&lst,mb,strlen(mb)+1);
	    ++n;
	    VERBOSE(DBGP("[%s]",mb));
	}
	ArAdd1(&lst,0);
	ImmReleaseContext(cx->Win,imc);
	VERBOSE(DBGP("\n"));
    }

    len = (n>0 ? lst.using : 0);
    if(len > bufsize){
	n = -1;
	len = 0;
    }
    st = Reply6(ch->Major,ch->Minor,n,lst.adr,len);
    ArDelete(&lst);
    return st;
}
