#include <stdio.h>
#include <string.h>
#include <regex.h>
#include <windows.h>
#include <ddk/imm.h>
#include <stdbool.h>
#include "ut.h"
#include "cannaapi.h"
#include "apisup.h"
#include "list.h"
#include <canna/keydef.h>

bool MsgLoop(UINT m,WPARAM wp);	//wime.c
HWND NewWin();
bool wm_ime_composition(CannaContext_t* cx,char mj);

extern struct GlobalData_t WimeData;

//01
/* ??? ƥֹ֤ȤˤʤäƤ뤬0ǤϤʤΤ */
bool wm_canna_init(CannaHeader* ch,int fd)
{
    int len,client_major,client_minor,n;
    uint16_t res[2];
    char *user;

    FuncRead(&len,4);
    len = Swap4(len);
    char data[len];
    FuncRead(data,len);
    VERBOSE(DBG("data='%s', fd=%d\n",data,fd));

    if(FindClient(fd) >= 0){
	//ʣν
	res[0] = res[1] = -1;
    }else{
	n = sscanf(data,"%d.%d",&client_major,&client_minor);
	if((user = strchr(data,':')) != NULL)
	    ++user;
	if(n!=2 || client_major>WIME_CANNA_MAJOR || user==NULL){
	    /* 줿ǡ
	       ᥸㡼С󤬤ʤȤRETURN_VERSION_ERROR_STAT֤ȤˤʤäƤ뤬ϤʥIRproto.hˤꡢlibcannaˤϴޤޤƤʤΤˤʥäƤΤݤʤΤǡإåե˽񤤤Ƥ
	       ޥʡСϤȤꤢ̵뤹롣
	       桼̾ʤΤ̤Υ顼ˤ٤ݤʤΤǡ
	    */
	    *(uint32_t*)res = Swap4(RETURN_VERSION_ERROR_STAT);
	    DBG("illegal data\n");
	}else{
	    res[0] = Swap2(WIME_CANNA_MINOR);
	    res[1] = Swap2(OpenConnection(fd,user));
	    VERBOSE(DBG("context=%hd fd=%d user='%s'\n",Swap2(res[1]),fd,user));
	}
    }
    return FuncWrite(res,4);
}

//02
bool wm_canna_finalize(CannaHeader* ch,int fd)
{
    char st = (CloseConnection(fd) ? 0:-1);
    VERBOSE(DBG("fd %d ,status %hhd\n",fd,st));
    return Reply2(0x02,0,st);
}

//03
bool wm_create_context(CannaHeader *ch,int fd)
{
    int16_t cxn=-1;
    if(FindClient(fd) >= 0)
	OpenContext(fd,NewWin(),&cxn);
    VERBOSE(DBG("context number %d,fd %d\n",cxn,fd));
    return Reply5(ch->Major,ch->Minor,cxn);
}

//04
bool wm_dup_context(CannaHeader *ch,int fd)
{
    int16_t orig,dup=-1;
    HIMC orig_imc,dup_imc;
    CANDIDATEFORM candi_form;
    LOGFONT logfont;
    COMPOSITIONFORM comp_form;
    DWORD conv_st,sentence_st;
    CannaContext_t *cxo,*cxd;

    orig = Req2(ch->Data.adr);
    VERBOSE(DBG("fd=%d, context=%hd\n",fd,orig));
    cxo = ValidContext(orig,__FUNCTION__);
    if(cxo != NULL){
	cxd = OpenContext(fd,NewWin(),&dup);

	dup_imc = ImmGetContext(cxd->Win);
	orig_imc = ImmGetContext(cxo->Win);
	
	ImmGetCandidateWindow(orig_imc,sizeof(CANDIDATEFORM),&candi_form);
	ImmSetCandidateWindow(dup_imc,&candi_form);

	ImmGetCompositionFont(orig_imc,&logfont);
	ImmSetCompositionFont(dup_imc,&logfont);

	ImmGetCompositionWindow(orig_imc,&comp_form);
	ImmSetCompositionWindow(dup_imc,&comp_form);

	ImmGetConversionStatus(orig_imc,&conv_st,&sentence_st);
	ImmSetConversionStatus(dup_imc,conv_st,sentence_st);

	ImmReleaseContext(cxo->Win,orig_imc);
	ImmReleaseContext(cxd->Win,dup_imc);

	ArCopy(&cxd->Dics,&cxo->Dics);
	ArCopy(&cxd->DicMode,&cxo->DicMode);

	VERBOSE(DBG("%d --> %d\n",(unsigned)orig,(unsigned)dup));
    }
    return Reply5(ch->Major,ch->Minor,dup);
}

//05
bool wm_close_context(CannaHeader* ch,int fd)
{
    char st=-1;
    CannaContext_t* cx;
    int16_t cxn = Req2(ch->Data.adr);
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	CloseContext(cx);
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*???
  06 GetDictionaryList	ơ֥ϿƤ뼭ΰ
  07 GetDirectoryList	ǥ쥯ȥˤ뼭ΰ
  0b GetMountDicList	ơ֥ϿƤ뼭ꥹ
  060bƱʤ졩
  atok
  06 Ѥ褦ꤷƤ뼭ΰ(ǥեȤμ񥻥å)
  07 Ѳǽʼΰ
  0b ޥȤƤ뼭ΰ
  ȤƤߤ롣
  imm-api˼ϢΤΤϤʤΤǡؤδؿϤɤ褦ʤ
*/
//06 [atok]
bool wm_get_dic_list(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t bufsize;
    Req3(ch->Data.adr,&cxn,&bufsize);
    VERBOSE(DBG("context=%hd, bufsize=%hd\n",cxn,bufsize));
    DBG("*** NOT IMPLIMENT ***\n"); 
    DBG("*** I DO NOTHING ***\n");
    return Reply6(ch->Major,ch->Minor,0,NULL,0); //ꥹȤʤｪλ
}

//07 [atok]
bool wm_get_dir_list(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t bufsize;
    Req3(ch->Data.adr,&cxn,&bufsize);
    VERBOSE(DBG("context=%hd, bufsize=%hd\n",cxn,bufsize));
    DBG("*** NOT IMPLIMENT ***\n"); 
    DBG("*** I DO NOTHING ***\n");
    return Reply6(ch->Major,ch->Minor,0,NULL,0);
}

//̾Ͽ
//08
bool wm_mount_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *name,st=-1;
    CannaContext_t *cx;

    name = Req15(ch->Data.adr,&mode,&cxn);
    VERBOSE(DBG("mode=0x%x context=%hd dic-name='%s'\n",mode,cxn,name);
	    DBG("*** I DO NOTHING ***\n"));
    if((cx = ValidContext(cxn,__FUNCTION__))!=NULL){
	char listterm=0;
	if(cx->Dics.using > 0)
	    -- cx->Dics.using; //ꥹȤνλޡȤ
	ArAddN(&cx->Dics,name,strlen(name)+1);
	ArAdd(&cx->Dics,&listterm);
	ArAdd(&cx->DicMode,&mode);
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

//̾
//09
bool wm_unmount_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *dicname,st=-1;
    CannaContext_t *cx;
    int dn;

    dicname = Req15(ch->Data.adr,&mode,&cxn);
    VERBOSE(DBG("mode=0x%x, context=%hd, dictionary name='%s'\n",mode,cxn,dicname);
	    DBG("*** I DO NOTHING ***\n"));
    if((cx = ValidContext(cxn,__FUNCTION__))!=NULL){
	if(cx->Dics.using>0 && (dn = ListFind(cx->Dics.adr,dicname))>0){
	    cx->Dics.using -= ListRemove(cx->Dics.adr,dn);
	    if(cx->Dics.using == 1) //ꥹȽλޡΤߤˤʤä
		cx->Dics.using = 0;
	    ArRemove(&cx->DicMode,dn);
	    st = 0;
	}else
	    VERBOSE(DBG("not found dictionary '%s'\n",dicname));
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*???
  ͤͥ٤Ȥ뤬ϤɤͤʤΤ
  褯狼ʤΤǡꤵ줿ꥹȤƬ˻äƤ롣
*/
//0a
bool wm_remount_dic(CannaHeader *ch,int fd)
{
    char *dicname;
    int32_t pr;
    int16_t cxn;
    CannaContext_t *cx;
    int dn;
    char st=-1;

    dicname = Req15(ch->Data.adr,&pr,&cxn);
    VERBOSE(DBG("context=%hd, priority=%d, dic-name='%s'\n",cxn,pr,dicname);
	    DBG("*** I DO NOTHING ***\n"));
    if((cx = ValidContext(cxn,__FUNCTION__))!=NULL){
	dn = ListFind(cx->Dics.adr,dicname);
	if(dn >= 0){
	    int mode = *(int32_t*)ArElem(&cx->DicMode,dn);
	    ArInsert(ArRemove(&cx->DicMode,dn),0,1,&mode);
	    ListRemove(cx->Dics.adr,dn);
	    ListInsert(cx->Dics.adr,0,dicname);
	    st = 0;
	}else
	    VERBOSE(DBG("not mount dictionary\n"));
    }
    return Reply2(ch->Major,ch->Minor,st);
}

//0b
bool wm_mount_dic_list(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t bufsize;
    int n=-1,len;
    char* p = NULL;
    CannaContext_t *cx;

    Req3(ch->Data.adr,&cxn,&bufsize);
    VERBOSE(DBG("context %hd, buffer size %hd\n",cxn,bufsize));
    if((cx = ValidContext(cxn,__FUNCTION__))!=NULL && (len=cx->Dics.using)<=bufsize)
	n = ListCount(p = cx->Dics.adr);
    return Reply6(ch->Major,ch->Minor,n,p,len);
}

//0c
bool wm_query_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *user,*dic;

    dic = Req19(ch->Data.adr,&mode,&cxn,&user);
    VERBOSE(DBG("context=%hd, mode=0x%x, user='%s', dic='%s'\n",cxn,mode,user,dic);	
	    DBG("*** NOT IMPLIMENT ***\n"));
    return Reply2(ch->Major,ch->Minor,-1);
}


/*
  ʤʻ쥳("#"ϤĤʤ)winοͥɤˤ
  ʻơ֥뤬ʤȤ0
  ??? IME_REGWORD_STYLE_USER_FIRSTImmRegisterWordǻȤȥ顼ˤʤä
  IME_REGWORD_STYLE_USER_FIRST+1ʹߤμ¤ˤȤƤΤ
  ΤȤǤϡʻбե뤬ʤХ顼ˤƤ
*/
int canna_hinshi_to_win(const char *can_code)
{
    HinshiCor* hc;
    regex_t reg;
    regmatch_t m;

    if((hc=WimeData.HinshiTab) == NULL){
	DBG("not found hinshi table\n");
	return 0;
    }
    for(; hc->Ccode!=NULL; ++hc){
	if(regcomp(&reg,hc->Ccode,REG_EXTENDED)==0){
	    if(regexec(&reg,can_code,1,&m,0)==0)
		break;
	    regfree(&reg);
	}
    }
    if(hc->Ccode != NULL)
	regfree(&reg);
    else{
	DBG("unknown part code:%s\n",can_code);
	hc=WimeData.HinshiTab; //Ƭˤ륳ɤ֤
    }
    return hc->Wcode;
}

//??? -mno-cygwinʤ?
//char *strtok_r(char*,const char*,char**);
/* gcc-HǸȡno-cygwinȤstring.h/usr/local/include/wine/msvcrt,
   ̵ȤϤʳ(/usr/include)ɤ߹Ǥ롣ǡwine-1.1.1ʳ
   msvcrt/string.hstrtok_r̵
   windowsǤstrtok_sߤǤwineˤϤʤ
*/
char* strtok_r_(char* s,const char* d,char** p)
{
    if(s == NULL)
	s = *p;
    if(s != NULL){
	s += strspn(s,d);
	if(*s != 0){
	    *p = s+strcspn(s,d);
	    if(**p != 0)
		*((*p)++) = 0;
	}else
	    *p = s = NULL;
    }
    return s;
}
#define strtok_s strtok_r_

//0d RkDefineDic
bool reg_or_unreg_word(CannaHeader *ch,BOOL WINAPI (*proc)(HKL,LPCTSTR,DWORD,LPCTSTR))
{
    int16_t cxn;
    char *dicname,*wordrec,*hinshi,*wrp,*tok;
    char *mb[2]/*ɤߤȴ*/;
    int sty;

    dicname = Req12(ch->Data.adr,&cxn,&wordrec);
    VERBOSE(DBG("context=%hd, words='%s', dic-name=%s\n",cxn,wordrec,dicname));

    wrp = wordrec;
    while((mb[0] = strtok_s(wrp," ",&tok)) != NULL){
	hinshi = strtok_s(NULL," ",&tok); //ʻ쥳ʸ
	mb[1] = strtok_s(NULL," ",&tok); //Ͽ
	if(hinshi==NULL || mb[1]==NULL){
	    DBG("illegal word info.\n");
	    break;
	}
	sty = canna_hinshi_to_win(hinshi+1);
	if(sty == 0){ //ʻơ֥뤬ʤ
	    mb[0] = ""; //顼ˤ뤿Ŭʥɥ쥹Ƥ
	    break;
	}
	VERBOSE(DBG("%s 0x%x %s\n",mb[0],sty,mb[1]));

	for(int n=0; n<2; ++n)
	    ConvCode(mb[n],mb[n],Ej2Sj);
	if(!proc(GetKeyboardLayout(0),mb[0],sty,mb[1])){
	    DBG("fail Imm(Un)RegisterWord\n");
	    break;
	}
	wrp = NULL;
    }
	
    return Reply2(ch->Major,ch->Minor,(mb[0]==NULL?0:-1));
}

//0d RkDefineDic
bool wm_define_word(CannaHeader *ch,int fd)
{
    return reg_or_unreg_word(ch,ImmRegisterWord);
}

//0e RkDeleteDic
bool wm_delete_word(CannaHeader *ch,int fd)
{
    return reg_or_unreg_word(ch,ImmUnregisterWord);
}

bool set_yomi_str(const CannaHeader* ch,CannaContext_t* cx,int sentence_mode,char* yomi,int32_t fer_mode)
{
    int r=0,n;
    uint16_t uc[ch->Length];
    HIMC imc = ImmGetContext(cx->Win);
    ImmSetOpenStatus(imc,TRUE);
    ImmSetConversionStatus(imc,IME_CMODE_FULLSHAPE|IME_CMODE_NATIVE,sentence_mode);
    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0); //Ƚλ򤷤ʤ翷HWNDǤΥǡĤäƤȤ롣

    /* euc-jp --> uc
       ??? ImmSetCompositionString()ȤȤʤߤդΤǡImmSetCompositionStringW()Ȥ
    */
    ConvCode(yomi,yomi,Ej2Sj);
    n = MultiByteToWideChar(CP_ACP,0,yomi,-1,uc,sizeof(uc)/sizeof(uc[0]))-1;

    if((r=ImmSetCompositionStringW(imc,SCS_SETSTR,uc,n*2,NULL,0))){
	if((r=ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0))){
	    cx->FerMode = fer_mode;
	    cx->Conv = 0;
	}else
	    DBGT("fail ImmNotifyIME()\n");
    }else
	DBGT("fail ImmSetCompositionString()\n");
    
    ImmReleaseContext(cx->Win,imc);
    return r!=0;
}

//0f RkBgnBun
bool wm_begin_conv(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    bool r=false;
    char *yomi;
    CannaContext_t *cx;

    yomi = Req14(ch->Data.adr,&mode,&cxn);
    VERBOSE(DBG("mode 0x%x, context %hd, yomi='%s'\n",mode,cxn,yomi));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	r = set_yomi_str(ch,cx,IME_SMODE_PHRASEPREDICT,yomi,mode);
    }
    return r ? wm_ime_composition(cx,ch->Major) : (cx->Conv=-1,Reply5(0x0f,0,-1));
}

//Ѵ⡼ɤɲäο֤
//append_fer_cand()⻲
int fer_mode_num(int32_t mode)
{
    int count;
    for(count=0; (mode&RK_XFERMASK)!=0; mode>>=RK_XFERBITS){
	//⡼0x0fϽ롣 ???Ϥʤ
	if((mode & RK_XFERMASK) != RK_XFERMASK)
	    ++ count;
    }
    return count;
}

/*
  ߤѴ̤ΥꥹȤ롣ꥹȽλΥ̥ʸɲä롣
  ͡ʸ
*/
int current_cand_list(int clstart,Array* lst,const CannaContext_t* cx,HIMC imc)
{
    int st,cllen;
    Array ej;
    char at;

    ArNew(&ej,2,NULL);
    st = 0; //ͭʸο
    cllen = ClauseLen(imc,cx);
    for(; clstart<cllen; ++clstart){
	ClauseStr(imc,clstart,&ej,1,&at,cx);
	if(at!=ATTR_TARGET_CONVERTED && at!=ATTR_CONVERTED && at!=ATTR_FIXEDCONVERTED)
	    break; //ޤѴƤʤФǽ
	wstr_add_wstr(lst,&ej);
	wstr_add_wc(lst,0);
	++ st;
    }
    if(st > 0)
	wstr_add_wc(lst,0); //ꥹȽλޡ
    ArDelete(&ej);
    return st;
}

/*
  begin_convert,resize_pause³
  WM_IME_COMPOSITIONν
  Context[cx].Convʸֹ

  ??? 1.5.1ޤǤϲäƤåޤƽƤ1.6.0ǤѴؿ
  Ƥå롼פ˹ԤľܤƤ֤Ȥˤatok21Ǥʤ
  ۤimeǤϤɤ å륿ߥ󥰤Ѵ٤ƽäȤ
  ޤʤΤ
  ä˼ưѴξ硢ŪѴ򤷤Ƥ櫓ǤϤʤä夹ˤδؿƤǤ뤬פ®ԥ塼ǡʸƱ˹Ԥ꤬ꤽʵ롣
  Ф餯ǤäƤߤơи᤽
*/
bool wm_ime_composition(CannaContext_t* cx,char mj)
{
    int st;
    Array candlist;
    bool ret;

    HIMC imc = ImmGetContext(cx->Win);
    VERBOSE(DBG("major code=0x%hhx, target clause number %d\n",mj,cx->Conv);DbgComp(imc,__FUNCTION__));
    SaveFixedClause(imc,cx); //Ѵ뤿Ӥ˸ʸϾ񤭤ƤޤΤ¸롣

    //ʬeucjpѴʤ饳ԡ
    ArNew(&candlist,2,NULL);
    st = current_cand_list(cx->Conv,&candlist,cx,imc); //ͭʸο
    if(st > 0)
	st += cx->Conv; //ResizePause֤ʸʸʹߤǤϤʤʸ
    VERBOSE(DBG("cl-count=%d, candi-data-size=%d, data=",st,candlist.using*2);
	    Dump1(" %02x",candlist.adr,candlist.using*2,1));

    ret = Reply7(mj,0,st,candlist.adr,candlist.using*candlist.blocksize);
    cx->Conv = -1;
    ImmReleaseContext(cx->Win,imc);
    ArDelete(&candlist);
    return ret;
}

/*
  ѴֹѴꥹȥڡֹȥڡֹˤ롣
  䥦ɥФʤȤ *page=-1
  Ƭλ顼λ-1

  !!! GetCandidacyListΥ⡼ɤɲä줿ɤߤʤɤ򤵤줿Ϥɤ롩
  ڡʤΤǥ顼ˤʤ롣
*/
int page_index(int cln,Array* candlistpage,int index,int* page)
{
    if(index > 0){ //Ƭʳ
	if(cln >= candlistpage->using){
	    *page = CANDLISTMAX; //ʸǸϽФƤʤ
	}else{
	    CandListPageInfo* pi = ArElem(candlistpage,cln);
	    if(pi->Seq > 0)
		*page = -1; //䥦ɥʤ
	    else{
		for(*page=0; *page<CANDLISTMAX; ++*page){
		    if(pi->Size[*page] == 0){ //ꥹȤʤ
			DBGP("candidate list page %d is none\n",*page);
			index = -1;
			break;
		    }
		    if(index < pi->Size[*page])
			break;
		    index -= pi->Size[*page];
		}
	    }
	}
	if(*page == CANDLISTMAX){
	    DBGP("candidate page not found\n");
	    index = -1;
	}
    }else{
	VERBOSE(DBGP("first candidate word\n"));
	index = -1;
    }
    return index;
}

//ǽŪѴimeȿǤ
void update_cand(HIMC imc,const int16_t* candnum,int len,Array* pi,const CannaContext_t* cx)
{
    int cn,page;
    for(int clnum=cx->FixedNum; clnum<len; ++clnum,++candnum){
	VERBOSE(DBG("clause %d:",clnum));
	if((cn=page_index(clnum,pi,*candnum,&page))>=0){
	    switch(ChangeTargetClause(imc,clnum,cx)){
	    case ChangeTargetSuccess:
		if(page >= 0){
		    if(ImmNotifyIME(imc,NI_OPENCANDIDATE,page,0) &&
		       ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,page,cn)){
			VERBOSE(DBG("candidate page %d,index %d\n",page,cn));
		    }else
			DBG("fail ImmNotifyIME\n");
		}else{
		    while(--cn >= 0)
			ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
		}
	    case ChangeTargetFixed:
		break;
	    case ChangeTargetFail:
		DBG("fail ChangeTargetClause\n");
	    }
	}
    }
}

//10 RkEndBun
bool wm_end_conv(CannaHeader *ch,int fd)
{
    int16_t cxn,clses,*candnums;
    int32_t mode;
    int numlen;
    CannaContext_t *cx;
    char st=-1;

    candnums = Req10(ch->Data.adr,&cxn,&clses,&mode,ch->Length);
    numlen = (ch->Length-8)/2;
    VERBOSE(DBG("context %hd, clauses %hd, mode %d, candidate list(%d)",cxn,clses,mode,numlen);
	    Dump2(" %hd",candnums,numlen,1));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	HIMC imc = ImmGetContext(cx->Win);
	ImmSetOpenStatus(imc,TRUE);
	//??? mode!=1ϥ󥻥ȤƤΤ
	if(mode==1){
	    update_cand(imc,candnums,numlen,&cx->CandInfo,cx);
	    st = ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_COMPLETE,0);
	    if(st)
		VERBOSE(DbgComp(imc,__FUNCTION__));
	}else
	    st = ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
	if(!st)
	    DBG("fail ImmNotifyIME\n");
	ImmSetOpenStatus(imc,FALSE);
	ImmNotifyIME(imc,NI_CLOSECANDIDATE,0,0); //???ʸɬפ
	ImmReleaseContext(cx->Win,imc);
	ResetContext(cx);
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*
  ⡼ɤˤäyomiѴƸꥹȤɲä
  ɲä֤
  ??? ⡼ɤ0xf(֤RK_CTRLHENKAN)ʤΤϲ
*/
int append_fer_cand(int mode,Array *lb,uint16_t *yomi)
{
    Array fer;
    int count=0;

    ArNew(&fer,2,NULL);
    for(; (mode&RK_XFERMASK)!=0; mode>>=RK_XFERBITS){
	switch(mode & RK_XFERMASK){
	case RK_HFER: //Ⱦʸ
	    VERBOSE(DBG("Hankaku\n"));
	    wstr_add_zen2han_ej(&fer,yomi);
	    break;
	case RK_KFER: //
	    VERBOSE(DBG("Katakana\n"));
	    wstr_add_wcs(&fer,yomi);
	    wstr_hira2kata_ej(&fer);
	    break;
	case RK_XFER: //Ҥ餬 ??? RK_ZFERȤΰ㤤ϡ
	    VERBOSE(DBG("Hiragana\n"));
	    wstr_add_wcs(&fer,yomi);
	    break;
	case RK_ZFER: //ʸ
	    VERBOSE(DBG("Zenkaku\n"));
	    wstr_add_wcs(&fer,yomi);
	}
	wstr_add_wstr(lb,&fer);
	wstr_add_wc(lb,0);
	ArClear(&fer);
	++count;
    }
    ArDelete(&fer);
    return count;
}

/*
  ѴeucjpˤƥꥹȤɲä롣
  euclistblocksize:2(wchar)
  ꥹȤο֤顼λ-1
*/
int lookup_cand_win(HIMC imc,Array *euclist,CandListPageInfo *pi,int clnum,const CannaContext_t* cx)
{
    Array candpage,cand;
    int n,cand_count,listnum;
    CANDIDATELIST *cb;

    if(!ImmNotifyIME(imc,NI_OPENCANDIDATE,0,0)){
	VERBOSE(DBG("can't open candidate list\n"));
	return -1;
    }

    ArNew(&candpage,1,NULL);
    ArNew(&cand,2,NULL);
    cand_count = listnum = 0;
    do{
	VERBOSE(DBG("ImmGetCandidateList,page %d\n",listnum));
	if((n = ImmGetCandidateList(imc,listnum,NULL,0)) == 0){
	    VERBOSE(DBG("page %d has no candidate list\n",listnum));
	    break;
	}
	ArReserve(&candpage,n);
	ImmGetCandidateList(imc,listnum,candpage.adr,candpage.reserve);

	//eucjpѴʤꥹȥХåեɲä
	cb = (CANDIDATELIST*)(candpage.adr);
	cand_count += cb->dwCount;
	pi->Size[listnum] = cb->dwCount;
	if(euclist != NULL){
	    for(n=0; n<cb->dwCount; ++n){
		/*???
		  atok2008ǤѴϸ촴롣ʤǤ꤬ʤޤ
		  ɬס
		  windowsǤθꥹȥɥǤ꤬ʤøɽƤ롣
		  ΤȤ꤬ʤμˡ狼ʤimm apiˤ̵
		  Ȥꤢ򣱤Ĥ򤷡ΤȤѴʸФ
		  ʥ饤ȤϤȤˤ롣
		  ۤimeǤƱ
		*/
		ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,listnum,n);
		wstr_add_wstr(euclist,ClauseStr(imc,clnum,&cand,1,NULL,cx));
		wstr_add_wc(euclist,0);
	    }
	}
    }while(++listnum<CANDLISTMAX && ImmNotifyIME(imc,NI_CHANGECANDIDATELIST,listnum,0));

#if 0
    //裱᤹
    if(listnum > 0)
	ImmNotifyIME(imc,NI_CHANGECANDIDATELIST,0,0);
    if(cand_count > 0)
	ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,0,0);
#endif
    ImmNotifyIME(imc,NI_CLOSECANDIDATE,0,0);
    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
    //??? ̤äƤޤΤǡѴ롣ʤǡ

    ArDelete(&candpage);
    ArDelete(&cand);
    return cand_count;
}

/*
  ѴeucjpˤƥꥹȤɲä롣
  euclistblocksize:2(wchar)
  ꥹȤο֤顼λ-1
  euclist==NULLǤok
*/
int make_cand_list(HIMC imc,Array* euclist,CandListPageInfo* pi,int clnum,const CannaContext_t* cx)
{
    int count=0;
    Array cand;
    bool open_cand_win;

    /*
      "䥦ɥɽޤǤɬפѴ"ΤȤImmGetCandidateListϣ֤ImmNotifyIMENI_OPENCANDIDATEꤷƤ䥦ɥɽʤʤȤʤʤΤǡimcϣܤѴ֤ǤȤơ̤Ѵ֤ˤʤޤImmNotifyIMEѴΤӤѴ̤Ͽ롣
      ˡѴꥹȤä硢ؤΥॢǤʤܤθǳꤷ٣ѴʤФʤʤʤΤǡѴåĴ١WM_IME_NOTIFY(IMN_OPENCANDIDATE)褿ƤޤǤƱѴ롣
      ƤʸǺǽ򤹤롢ȤϤޤ̵ˡˤнϴñ(ޤǤˡǤ򤷤Ƥ)CandListPageInfoɬפʤʤΤɤ뤫
      uimϲ뤿ӤʸθĴ٤ä㤯٤ʤʡᤫ
    */
    ArNew(&cand,2,NULL);
    do{
	if(euclist!=NULL){
	    wstr_add_wstr(euclist,ClauseStr(imc,clnum,&cand,1,NULL,cx));
	    wstr_add_wc(euclist,0);
	}
	++count;
	ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
	open_cand_win = MsgLoop(WM_IME_NOTIFY,IMN_OPENCANDIDATE);
    }while(!open_cand_win && GetAttr(imc,clnum,cx)!=ATTR_TARGET_NOTCONVERTED);

    if(open_cand_win){
	//ꥻåȤƤľ
	if(euclist!=NULL)
	    euclist->using = 0;
	count = lookup_cand_win(imc,euclist,pi,clnum,cx);
    }else{
	//ܤѴ֤᤹
	ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
	pi->Seq = count;
    }
    ArDelete(&cand);
    return count;
}

//11
bool wm_get_candi_list(CannaHeader *ch,int fd)
{
    int16_t cxn,cls_num,cand_count=-1;//顼
    uint16_t bufsize;
    HIMC imc;
    int usingbytes;
    Array euclist;
    CannaContext_t *cx;
    void *st=NULL;//顼
    bool ret;

    Req6(ch->Data.adr,&cxn,&cls_num,&bufsize);
    VERBOSE(DBG("context %d,clause-number %d,buffer size=%u\n",cxn,cls_num,bufsize));
    if((cx=ValidContext(cxn,__FUNCTION__)) != NULL){
	imc = ImmGetContext(cx->Win);
	ArNew(&euclist,2,NULL);
	switch(ChangeTargetClause(imc,cls_num,cx)){ //ʸѹ
	case ChangeTargetSuccess:
	    if(cls_num < cx->CandInfo.using)
		//ǰΤξϾäƤ
		memset(ArElem(&cx->CandInfo,cls_num),0,sizeof(CandListPageInfo));
	    else
		ArAlloc(&cx->CandInfo,cls_num+1); //ʸޤǤϳݤ
	    cand_count = make_cand_list(imc,&euclist,ArElem(&cx->CandInfo,cls_num),cls_num,cx);
	    if(cand_count >= 0){
#if 0
		//[1.8.5]cand_count0ˤʤ뤳Ȥ̵Ȼפ
                if(cand_count == 0){
                    /* Ѵ̰ʳ˸䤬ʤѴ̤ */
                    ClauseStr(imc,cls_num,&euclist,1,NULL,cx);
                    wstr_add_wc(&euclist,0);
                    ++cand_count;
                }
#endif
		//ɤߤɲ
		Array yomi;
		ArNew(&yomi,2,NULL);
		GetInputClause(imc,cls_num,cls_num,cx,&yomi);
		cand_count += append_fer_cand(cx->FerMode,&euclist,yomi.adr); //⡼ɤˤäƸꥹȤɲä
		wstr_add_wstr(&euclist,&yomi); //ɤߤɲ
		wstr_add_wc(&euclist,0);	//ɤߤΥ̥ʸ
		wstr_add_wc(&euclist,0);	//ꥹȽλ򼨤̥ʸ

		ArDelete(&yomi);
		VERBOSE(DBG("list=%d, ",cand_count); DumpList2(euclist.adr,1));

		usingbytes = euclist.using * euclist.blocksize;
		if(usingbytes > bufsize){
		    DBG("bufsize too small,need %d\n",usingbytes);
		    cand_count = -1;
		}else
		    st = euclist.adr; //
	    }
	    break;
	case ChangeTargetFixed:
	    VERBOSE(DBG("this clause is fixed\n"));
	    break;
	case ChangeTargetFail:
	    DBG("fail ChangeTargetClause\n");
	}
    }
    ret = Reply7(ch->Major,ch->Minor,cand_count,st,usingbytes);
    ArDelete(&euclist);
    ImmReleaseContext(cx->Win,imc);
    return ret;
}

//12
bool wm_get_yomi(CannaHeader *ch,int fd)
{
    int16_t cxn,cls_num;
    uint16_t bufsize;
    HIMC imc;
    int len=-1; //顼
    int sz;
    bool st;
    CannaContext_t *cx;
    Array yomi;

    ArNew(&yomi,2,NULL);
    Req6(ch->Data.adr,&cxn,&cls_num,&bufsize);
    VERBOSE(DBG("context=%hd, clause=%hd, bufsize=%hd\n",cxn,cls_num,bufsize));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	imc = ImmGetContext(cx->Win);
	GetInputClause(imc,cls_num,cls_num,cx,&yomi);
	sz = ((len = yomi.using)+1)*2;
	if(sz <= bufsize){
	    VERBOSE(DBG("yomi:[%s]\n",(char*)yomi.adr));
	}else{
	    DBG("buffer too small\n");
	    len = -1;
	}
    }
    st = (len!=-1 ? Reply7(0x12,0,len,yomi.adr,sz) : Reply5(0x12,0,-1));
    ArDelete(&yomi);
    ImmReleaseContext(cx->Win,imc);
    return st;
}

//եȥξ֤򥻥åȤ
void set_state(unsigned char state,uint16_t vk,unsigned char keytab[])
{
    if((vk & 0x100) != 0){ //ե
	GetKeyboardState(keytab);
	keytab[VK_SHIFT]=state;
	SetKeyboardState(keytab);
    }
}

/*???
  '>','?'ʤɥեȥɬפʾ硢SetKeyboardState()̵֤ѹƤ롣 SendInput()ʤɤȤ٤ ⤽⺬Ū˥ץְäƤ뵤롣
*/
bool proc_key_vk(uint16_t vk,char ch,HWND wh,HKL kl)
{
    bool st = false;
    uint32_t vkch = vk&0xff; //ۥ(եȤʤ)
    uint32_t sc = MapVirtualKeyEx(vkch,0,kl); //ۥɢ󥳡
    uint32_t pk = (sc<<16)|1; //ImmProcessKeyѤΥ󥳡
    unsigned char kst[256];

    set_state(0xff,vk,kst);
    if(ImmProcessKey(wh,kl,vkch,pk,0)){
	if(ImmTranslateMessage(wh,WM_KEYDOWN,VK_PROCESSKEY,pk))
	    st = true;
	else
	    DBG("fail ImmTranslateMessage(),charcode=0x%hhx, vkey=0x%hx, scancode=0x%x\n",ch,vk,sc);
    }else{
	VERBOSE(DBG("fail ImmProcessKey(),code=0x%hhx, vkey=0x%hx, scancode=0x%x\n",ch,vk,sc));
    }
    set_state(0,vk,kst);
    return st;
}
bool proc_key(char ch,HWND wh,HKL kl)
{
    return proc_key_vk(VkKeyScanEx(ch,kl),ch,wh,kl); //ʸɢۥ
}

/*
  eucjpѤҤ餬ʤ޻ˤHWND
*/
bool send_roman(const char* yomi,HWND wh,HKL kl)
{
    bool st=true;
    char roman[strlen(yomi)*3+1];
    for(char* rp=Zen2Roman(roman,yomi); *rp!=0; ++rp){
	if(!proc_key(*rp,wh,kl)){
	    st = false;
	    break;
	}
    }
    return st;
}

//13
bool wm_subst_yomi(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t beg,end,len;
    char *yomi;
    CannaContext_t* cx;
    bool st;

    yomi = Req4(ch->Data.adr,&cxn,&beg,&end,&len);
    VERBOSE(DBG("context=%hd, begin=%hd, end=%hd, length=%hd, yomi=%s\n",cxn,beg,end,len,yomi);
	    DBG("yomi dump:");Dump1(" %02x",yomi,strlen(yomi),1));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	HKL kl = GetKeyboardLayout(0);
	if(len==0 && beg==end){
	    /*??? ڡ(Ѵ)򲡤ĹʸʤǸƤӽФ롣
	      Фʸ֤ȡFlushYomi褦
	      ??? 1.7.0:ѴƤȤbsʤɤϤƤ
	      ƤӽФ(beg<end)ߤѴ֤֤Τ
	      ??? 1.8.1:Ѵλ(beg==end)>0,ʸ֤FlushYomi
	      ǡ޻λҲλbsǽ(beg==end)==0Ǹߤ
	      Ѵ֤֤(ʤʸʸ
	    */
	    int cln=0;
	    Array lst;
	    ArNew(&lst,2,NULL);
	    if(beg == 0){
		HIMC imc = ImmGetContext(cx->Win);
		cln = current_cand_list(0,&lst,cx,imc);
		ImmReleaseContext(cx->Win,imc);
	    }
	    st = Reply7(ch->Major,ch->Minor,cln,lst.adr,lst.using*lst.blocksize);
	    ArDelete(&lst);
	}else{
	    while(++beg <= end)
		proc_key('\b',cx->Win,kl); /* ɤʸν */
	    if(send_roman(yomi,cx->Win,kl)){ /* Ǹɲ */
		cx->Conv = 0;
		st = wm_ime_composition(cx,ch->Major);
	    }else
		st = Reply5(ch->Major,ch->Minor,-1); //顼
	}
    }else
	st = Reply5(ch->Major,ch->Minor,-1);
    return st;
}

//14
bool wm_store_yomi(CannaHeader *ch,int fd)
{
    int16_t cxn,cl;
    char *yomi;
    CannaContext_t* cx;
    bool st;

    yomi = Req11(ch->Data.adr,&cxn,&cl);
    VERBOSE(DBG("context=%hd, clause=%hd, yomi='%s'\n",cxn,cl,yomi));

    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	Array scs[CS_MAX];
	HIMC imc = ImmGetContext(cx->Win);
	CompNew(scs);

	StoreComp(scs,imc,0,cl,EN_ALL);
	LoadComp(scs,imc);
	send_roman(yomi,cx->Win,GetKeyboardLayout(0));
	if(cx->CandInfo.using > cl+1)
	    cx->CandInfo.using = cl+1; //clޤ

	CompDelete(scs);
	ImmReleaseContext(cx->Win,imc);
	
	cx->Conv = 0;
	st = wm_ime_composition(cx,ch->Major);
    }else
	st = Reply5(0x14,0,-1);
    return st;
}

/*???
  ɤȤ˸ƤФ Ȥꤢ줿ȤˤƤߤ롣
*/
//15
bool wm_store_range(CannaHeader *ch,int fd)
{
    int16_t cxn,cl;
    char *yomi;
    CannaContext_t *cx,*tmpcx=NULL;
    Array cs[CS_MAX],cand;
    HIMC imc,tmpimc;
    bool st;

    yomi = Req11(ch->Data.adr,&cxn,&cl);
    VERBOSE(DBG("context=%hd, clause=%hd, yomi='%s'\n",cxn,cl,yomi));

    ArNew(&cand,2,NULL);
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL &&
       cl >= cx->FixedNum &&
       (tmpcx = OpenContext(fd,NewWin(),NULL))!=NULL &&
       set_yomi_str(ch,tmpcx,IME_SMODE_SINGLECONVERT,yomi,0)){
	imc = ImmGetContext(cx->Win);
	tmpimc = ImmGetContext(tmpcx->Win);
	CompNew(cs);

	ChangeTargetClause(imc,cl,cx);//imctmpimcʸ᤬Ťʤʤ褦ˤ
	cl -= cx->FixedNum;
	StoreComp(cs,imc,0,cl,EN_ALL);		//cl-1ޤ
	StoreComp(cs,tmpimc,0,-1,EN_ALL);	//ñʸѴcl
	StoreComp(cs,imc,cl+1,-1,EN_ALL);	//cl+1ʹ
	if(LoadComp(cs,imc)){
	    if(cx->CandInfo.using > cl+1)
		cx->CandInfo.using = cl+1; //clޤ
	    ClauseStr(imc,cl+cx->FixedNum,&cand,1,NULL,cx);
	    ArAdd1(&cand,0);
	    VERBOSE(DbgComp(imc,__FUNCTION__));
	}else
	    VERBOSE(DBG("fail load_comp()\n"));

	CompDelete(cs);
	ImmReleaseContext(cx->Win,imc);
	ImmReleaseContext(tmpcx->Win,tmpimc);
    }

    CloseContext(tmpcx);
    st = Reply3(ch->Major,ch->Minor,(cand.using>0?0:-1),cand.adr,cand.using*cand.blocksize);
    ArDelete(&cand);
    return st;
}

//16
bool wm_get_last_yomi(CannaHeader *ch,int fd)
{
    int16_t cxn,nul=0,st=-1;
    uint16_t bufsize;
    Array ej;
    CannaContext_t* cx;
    bool ret;

    ArNew(&ej,2,NULL);
    Req3(ch->Data.adr,&cxn,&bufsize);
    VERBOSE(DBG("context=%hd, bufsize=%hd\n",cxn,bufsize));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	int n;
	HIMC imc = ImmGetContext(cx->Win);
	if((n = GetAttrCl(imc,ATTR_INPUT,cx)) >= 0){
	    ArAdd(ClauseStr(imc,n,&ej,1,NULL,cx),&nul);
	    st = WcLen(ej.adr);
	    VERBOSE(DBG("cl-num=%d, string='%s'\n",n,(char*)ej.adr));
	}else{
	    st = 0;
	    VERBOSE(DBG("noting\n"));
	}
	ImmReleaseContext(cx->Win,imc);
    }
    ret = Reply7(0x16,0,st,(st>0?ej.adr:NULL),(st+1)*2);
    ArDelete(&ej);
    return ret;
}

//17
bool wm_flush_yomi(CannaHeader *ch,int fd)
{
    int16_t cxn,cl,*cand;
    int32_t mode,n;
    bool st=false;
    CannaContext_t* cx;

    cand = Req10(ch->Data.adr,&cxn,&cl,&mode,ch->Length);
    VERBOSE(DBG("context=%hd, clause=%hd, mode=%d, candidate=",cxn,cl,mode); Dump2("%hd ",cand,(ch->Length-8)/2,1));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	HIMC imc = ImmGetContext(cx->Win);
	Array scs[CS_MAX],*at=scs+CS_STRATTR;
	char a;

	/*ѴƤʤʸ᤬뤫*/
	CompNew(scs);
	StoreComp(scs,imc,0,-1,EN_STRATTR);
	for(n=0; n<at->using; ++n){
	    a = *(char*)ArElem(at,n);
	    if(a==ATTR_INPUT || a==ATTR_TARGET_NOTCONVERTED)
		break;
	}
	cx->Conv = 0;
	cx->FerMode = mode;
	if(n < at->using){
	    //ִ̤ʸ᤬
	    if(ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0)){
		st = true; //ȤWM_IME_COMPOSITIONåνǤ
	    }else
		DBG("fail ImmNotifyIME\n");
	}else{
	    //ǤѴѤ
	    VERBOSE(DBG("already convert\n"));
	    st = true; //??? ޤѴ
	}
	CompDelete(scs);
	ImmReleaseContext(cx->Win,imc);
    }
    return st ? wm_ime_composition(cx,ch->Major) : Reply5(0x17,0,-1);
}

/*???
  StoreRangeƱĻȤ뤫狼ʤѴʸʾˤʤäƤФΤ?
  ѥåȤʸʸǤΤʸʹߤλĤʸ
*/
//18
bool wm_remove_yomi(CannaHeader *ch,int fd)
{
    int16_t cxn,cl,*cand;
    int32_t mode;
    CannaContext_t *cx;
    bool st=false;
    char clall=-1; //ʸ
    HIMC imc;

    cand = Req10(ch->Data.adr,&cxn,&cl,&mode,ch->Length);
    VERBOSE(DBG("context=%hd, clause=%hd, mode=%d, candidate=",cxn,cl,mode);
	    Dump2("%hd ",cand,(ch->Length-8)/2,1));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	st = true;
	imc = ImmGetContext(cx->Win);
	if(mode && cl>=cx->FixedNum)
	    update_cand(imc,cand,cl-cx->FixedNum+1,&cx->CandInfo,cx);
	if(cl < cx->FixedNum-1){
	    //ʸΤߺ(ʸϣİʾĤ)
	    Array *fx[]={&cx->FixedStr,&cx->FixedYomi};
	    uint16_t *p;
	    for(int n=0; n<2; ++n){
		p = StrListNthWc(fx[n]->adr,cx->FixedNum,cl+1);
		fx[n]->using -= p - (uint16_t*)(fx[n]->adr); //ĤĹ
		memcpy(fx[n]->adr,p,fx[n]->using*fx[n]->blocksize);
	    }
	    cx->FixedNum -= cl+1;
	    VERBOSE(DBG("fixed clauses %d\n",cx->FixedNum));
	}else{
	    //ʸ̤ʸϺ뤫⤷ʤ
	    if(cl >= cx->FixedNum){
		Array scs[CS_MAX];
		CompNew(scs);
		ChangeTargetClause(imc,cl+1,cx);
		StoreComp(scs,imc,cl+1-cx->FixedNum,-1,EN_ALL);
		if((st = LoadComp(scs,imc)))
		    VERBOSE(DbgComp(imc,__FUNCTION__));
		else
		    VERBOSE(DBG("fail LoadComp()\n"));
		CompDelete(scs);
	    }
	    cx->FixedNum = 0;
	    ArDelete(&cx->FixedStr);
	    ArDelete(&cx->FixedYomi);
	}
	if(st){
	    clall = cx->FixedNum+ClauseLen(imc,cx);

	    /* clޤǤθ󤬤оä˵ͤ */
	    int len = cx->CandInfo.using - cl - 1;
	    if(len >= 0){
		memcpy(cx->CandInfo.adr,ArElem(&cx->CandInfo,cl+1),len*cx->CandInfo.blocksize);
		cx->CandInfo.using = len;
		VERBOSE(DBG("new candinfo length=%d\n",len));
	    }
	}
	ImmReleaseContext(cx->Win,imc);
    }
    //??? ȤꤢĤʸ֤Ƥߤ
    return Reply2(ch->Major,ch->Minor,clall);
}

//19
bool wm_get_simple_kanji(CannaHeader *ch,int fd)
{
    int16_t cxn;
    char *dic,*yomi;
    uint16_t yomi_len,cand_bufsize,hinshi_bufsize;

    dic = Req13(ch->Data.adr,&cxn,&yomi,&yomi_len,&cand_bufsize,&hinshi_bufsize);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, dic=%s, yomi='%s', yomi-len=%hd, cand-bufsize=%hd, hinshi-bufsize=%hd\n",cxn,dic,yomi,yomi_len,cand_bufsize,hinshi_bufsize));
    return Reply5(ch->Major,ch->Minor,-1);
}

//1a
bool wm_resize_pause(CannaHeader *ch,int fd)
{
    int16_t cxn,clnum,act;
    int st=0,*cls,*rcls;
    HIMC imc=NULL;
    char dum[5];
    CannaContext_t *cx;
    Array yomi,scs[CS_MAX],*cls_a=scs+CS_STRCL,*rcls_a=scs+CS_READCL;

    CompNew(scs);
    ArNew(&yomi,2,NULL);
    Req7(ch->Data.adr,&cxn,&clnum,&act);
    VERBOSE(DBG("context=%hd, clause=%hd, action=%hd\n",cxn,clnum,act));
    if((cx = ValidContext(cxn,__FUNCTION__))!=NULL && clnum>=cx->FixedNum){
	imc = ImmGetContext(cx->Win);
	StoreComp(scs,imc,0,-1,EN_STRCL|EN_READCL);
	++ cls_a->using; //ǸǡʸˤȤ
	++ rcls_a->using;
	cls = cls_a->adr;
	rcls = rcls_a->adr;
	switch(ChangeTargetClause(imc,clnum,cx)){
	case ChangeTargetSuccess:
	    switch(act){
	    case -1: //ʸ򿭤Ф  ʸγϰ֤ʸ
		++ cls[clnum+1];
		GetInputClause(imc,clnum+1,clnum+1,cx,&yomi);
		rcls[clnum+1] += EjZen2Han(dum,yomi.adr);
		st = 1;
		break;
	    case -2: //ʸ̤  ʸγϰ֤ʸ
		-- cls[clnum+1];
		/*
		  ʸĴ
		  ʸκǸУʸ̤ʤФʤʤ(""Ȥ)
		*/
		GetInputClause(imc,clnum,clnum,cx,&yomi);
		rcls[clnum+1] -= EjZen2Han(dum,ArElem(&yomi,yomi.using-1));
		st = 1;
		break;
	    default:
		DBG("illegal action\n");
	    }
	    break;
	case ChangeTargetFixed:
	    VERBOSE(DBG("this clause is fixed\n"));
	    break;
	case ChangeTargetFail:
	    DBG("fail ChangeTargetClause()\n");
	}
    }
    if(st){
	st = ImmSetCompositionStringW(imc,SCS_CHANGECLAUSE,cls,cls_a->using*cls_a->blocksize,rcls,rcls_a->using*rcls_a->blocksize);
	if(st){ //ʸȱʸ᤬ƶ뢪CandInfo򣰤᤹
	    if(clnum < cx->CandInfo.using){
		int n=1;
		if(clnum+1 < cx->CandInfo.using)
		    ++n;
		memset(ArElem(&cx->CandInfo,clnum),0,n*sizeof(CandListPageInfo));
	    }
	}else
	    DBG("fail ImmSetCompositionStringW\n");
    }
    if(imc!=NULL)
	ImmReleaseContext(cx->Win,imc);
    CompDelete(scs);
    ArDelete(&yomi);
    return st ? (cx->Conv=clnum,wm_ime_composition(cx,ch->Major)) : Reply5(0x1a,0,-1);
}

//1b
bool wm_get_hinshi(CannaHeader *ch,int fd)
{
    int16_t cxn,cl,cand;
    uint16_t bufsize;

    Req8(ch->Data.adr,&cxn,&cl,&cand,&bufsize);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, clause=%hd, candidate=%hd, bufsize=%hu\n",cxn,cl,cand,bufsize));
    return Reply2(ch->Major,ch->Minor,-1);
}

//1c
bool wm_get_lex(CannaHeader *ch,int fd)
{
    int16_t cxn,cl,cand,bufsize;

    Req9(ch->Data.adr,&cxn,&cl,&cand,&bufsize);
    DBG("*** NOT IMPLIMENT ***\n"); 
    VERBOSE(DBG("context=%hd, clause=%hd, candidate=%hd, bufsize=%hd\n",cxn,cl,cand,bufsize));
    return Reply5(ch->Major,ch->Minor,-1);
}

//1d RkGetStat
bool wm_get_status(CannaHeader *ch,int fd)
{
    int16_t cxn,clnum,cand;
    CannaContext_t *cx;
    bool ret;

    Req7(ch->Data.adr,&cxn,&clnum,&cand);
    VERBOSE(DBG("context=%hd, clause number=%hd, candidate number=%hd\n",cxn,clnum,cand));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	Array e;
	int cand_count=-1;
	HIMC imc = ImmGetContext(cx->Win);
	ArNew(&e,2,NULL);
	cx->RkSt.bunnum = clnum;
	cx->RkSt.candnum = cand;

	/* [1.8.4]uimǤϸꥹȤФˤapiƤФ餷Τǡ
	   Ĵ٤ */
	CandListPageInfo *pi = ArElem(&cx->CandInfo,clnum);
	if(clnum>=cx->CandInfo.using || (pi->Seq==0 && pi->Size[0]==0)){
	    /* ʸǸꥹȤФƤʤ
	       䤬ʤäȤSize[0]0ˤʤ롣ꥹȤĴ٤ɤ
	       狼ʤΤǡΤȤϤƺĴ٤롣Τ˥ե饰ɲ
	       Τ⤦äȤ[1.8.5]䤬̵Ƥpi->Seq1ˤʤ(Ϥ)*/
	    ArAlloc(&cx->CandInfo,clnum+1);
	    pi = ArElem(&cx->CandInfo,clnum);
	    switch(ChangeTargetClause(imc,clnum,cx)){
	    case ChangeTargetSuccess:
		cand_count = make_cand_list(imc,NULL,pi,clnum,cx);
		break;
	    case ChangeTargetFixed:
		VERBOSE(DBG("this clause is fixed\n"));
		break;
	    case ChangeTargetFail:
		DBG("fail ChangeTargetClause\n");
	    }
	}
	cx->RkSt.diccand = pi->Seq;
	for(int n=0; n<CANDLISTMAX; ++n)
	    cx->RkSt.diccand += pi->Size[n];

	cx->RkSt.maxcand = cx->RkSt.diccand + fer_mode_num(cx->FerMode);
	// ylen,klenϥХȿǤϤʤʸ
	cx->RkSt.ylen = GetInputClause(imc,clnum,clnum,cx,&e)->using;
	cx->RkSt.klen = ClauseStr(imc,clnum,&e,0,NULL,cx)->using;
	cx->RkSt.tlen = 1; //??? ϲ
	ArDelete(&e);
	ImmReleaseContext(cx->Win,imc);

	VERBOSE(DBG("bunnum=%d, candnum=%d, maxcand=%d, diccand=%d, ylen=%d, klen=%d, tlen=%d\n",cx->RkSt.bunnum,cx->RkSt.candnum,cx->RkSt.maxcand,cx->RkSt.diccand,cx->RkSt.ylen,cx->RkSt.klen,cx->RkSt.tlen));
	ret = Reply4(0x1d,0,0,(int32_t*)(&cx->RkSt),sizeof(RkStat)/4);
    }else
	ret = Reply2(0x1d,0,-1);
    return ret;
}

//1e
bool wm_set_locale(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *loc;

    loc = Req15(ch->Data.adr,&mode,&cxn);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, mode=%d, locale=%s\n",cxn,mode,loc));
    return Reply2(ch->Major,ch->Minor,-1);
}

/*???
  ɤ褦 IME_SMODE_AUTOMATICˤɤ߲̾򥻥åȤƤⲿⵯʤ
  ImmNotifyIME()ѴǤ뤬Ǥ̤ϢʸѴѤʤ
  饤ȤƤɤ߲̾޻ᤷϤȤime뤳Ȥˤ롣
  Ϥޤ⤦äȤޤˡϤʤ
*/
//1f
bool wm_auto_conv(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t bufsize;
    int32_t mode;
    HIMC imc;
    CannaContext_t *cx;
    char st=-1;

    Req5(ch->Data.adr,&cxn,&bufsize,&mode);
    VERBOSE(DBG("context=%hd, bufsize=%hd, mode=0x%x\n",cxn,bufsize,mode));
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	imc = ImmGetContext(cx->Win);
	ImmSetOpenStatus(imc,TRUE);
	ImmSetConversionStatus(imc,IME_CMODE_NATIVE|IME_CMODE_FULLSHAPE|IME_CMODE_ROMAN,IME_SMODE_AUTOMATIC);
	ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
	ImmReleaseContext(cx->Win,imc);
	cx->FerMode = mode;
	st=0;
    }
    return Reply2(0x1f,0,st);
}

//20
bool wm_query_ext(CannaHeader *ch,int fd)
{
    static const char name[]=
	"GetServerInfo\0"	"GetAccessControlList\0"
	"CreateDictionary\0"	"DeleteDictionary\0"
	"RenameDictionary\0"	"GetWordTextDictionary\0"
	"ListDictionary\0"	"Sync\0"
	"ChmodDictionary\0"	"CopyDictionary\0"

	"WimeOpenIMEDialog\0"	"WimeListContext\0"
	"WimeSendChar\0";

    VERBOSE(DBG("req-name-dump:");Dump1(" %02x",ch->Data.adr,ch->Length,1));
    return Reply2(0x20,0,SubList(name,ch->Data.adr));
}

/*???
  ⡼ɤȥƥȤϤɤäȤ˻Ȥ
  ƥȤꤵȤȤϡƥȤȤ˥ץ̾ꤵȤȡ
*/
//21
bool wm_set_app_name(CannaHeader *ch,int fd)
{
    char *name;
    int32_t mode;
    int16_t cxn;

    name = Req15(ch->Data.adr,&mode,&cxn);
    VERBOSE(DBG("mode %d,context %hd,name %s\n",mode,cxn,name);
	    DBG("ignore mode and context\n"));
    ((ClientData_t*)ArElem(&Clients,FindClient(fd)))->App = strdup(name);
    return Reply2(ch->Major,ch->Minor,0);
}

//22
bool wm_notice_group(CannaHeader *ch,int fd)
{
    char *name;
    int32_t mode;
    int16_t cxn;

    name = Req15(ch->Data.adr,&mode,&cxn);
    VERBOSE(DBG("mode %d,context %hd,group %s\n",mode,cxn,name);
	    DBG("ignore mode and context\n"));
    ((ClientData_t*)ArElem(&Clients,FindClient(fd)))->Group = strdup(name);
    return Reply2(ch->Major,ch->Minor,0);
}

//24
bool wm_kill_server(CannaHeader *ch,int fd)
{
    extern HMODULE LibCn;
    VERBOSE(DBG("kill wime\n"));
    Reply2(ch->Major,ch->Minor,0);
    ((PROT_SEL)GetProcAddress(LibCn,"ImCloseAll"))();
    PostQuitMessage(0);
    return true;
}

//1-01
bool wm_get_server_info(CannaHeader *ch,int fd)
{
    DBG("*** NOT IMPLIMENT ***\n");
    return Reply2(ch->Major,ch->Minor,-1);
}

//1-02
bool wm_get_acl(CannaHeader *ch,int fd)
{
    DBG("*** NOT IMPLIMENT ***\n");
    return Reply5(ch->Major,ch->Minor,-1);
}

//1-03
bool wm_create_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *dic;

    dic = Req15(ch->Data.adr,&mode,&cxn);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, mode=%d, dic=%s\n",cxn,mode,dic));
    return Reply2(ch->Major,ch->Minor,-1);
}

//1-04
bool wm_delete_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *dic;

    dic = Req15(ch->Data.adr,&mode,&cxn);
    DBG("*** NOT IMPLIMENT ***\n"); 
    VERBOSE(DBG("context=%hd, mode=%d, dic=%s\n",cxn,mode,dic));
    return Reply2(ch->Major,ch->Minor,-1);
}

//1-05
bool wm_rename_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *cur_dic,*new_dic;

    new_dic = Req19(ch->Data.adr,&mode,&cxn,&cur_dic);
    DBG("*** NOT IMPLIMENT ***\n"); 
    VERBOSE(DBG("context=%hd, mode=%d, current-dic=%s, new-dic=%s\n",cxn,mode,cur_dic,new_dic));
    return Reply2(ch->Major,ch->Minor,-1);
}

//1-06
bool wm_get_word_text_dic(CannaHeader *ch,int fd)
{
    int16_t cxn;
    char *dir,*dic;
    uint16_t bufsize;

    bufsize = Req18(ch->Data.adr,&cxn,&dir,&dic);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, directory=%s, dic=%s, bufsize=%hu\n",cxn,dir,dic,bufsize));
    return Reply5(ch->Major,ch->Minor,-1);
}

//1-07
/* ɥȤǤ׵᥿18ˤʤäƤ롣
   Υץȥ륿 i16,s8,u16 򥿥16ˤ
*/
bool wm_list_dic(CannaHeader *ch,int fd)
{
    int16_t cxn;
    uint16_t bufsize;
    char *dirs;

    bufsize = Req16(ch->Data.adr,&cxn,&dirs);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, bufsize=%hu, dir=%s\n",cxn,bufsize,dirs));
    return Reply2(ch->Major,ch->Minor,-1);
}

//1-08
bool wm_sync(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *dic;

    dic = Req15(ch->Data.adr,&mode,&cxn);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, mode=%d, dic=%s\n",cxn,mode,dic));
    return Reply2(ch->Major,ch->Minor,-1);
}

//1-09
bool wm_chmod_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *dic;

    dic = Req15(ch->Data.adr,&mode,&cxn);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, mode=%d, dic=%s\n",cxn,mode,dic));
    return Reply5(ch->Major,ch->Minor,-1);
}

//1-0a
bool wm_copy_dic(CannaHeader *ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char *dir,*src,*dst;

    dst = Req21(ch->Data.adr,&mode,&cxn,&dir,&src);
    DBG("*** NOT IMPLIMENT ***\n");
    VERBOSE(DBG("context=%hd, mode=%d, dir=%s, source=%s, destination=%s\n",cxn,mode,dir,src,dst));
    return Reply2(ch->Major,ch->Minor,-1);
}

/*
  ׵ᡧtype2
	i16  ܥåμ
		0=ץѥƥ
		1=ñ졿Ͽ
		2=桼
  type2
	i8   顼λ=-1

  ??? IME_CONFIG_REGISTERWORDԤΤϤʤ
*/
bool wm_wime_dialog(CannaHeader* ch,int fd)
{
    int modes[]={IME_CONFIG_GENERAL,IME_CONFIG_REGISTERWORD,IME_CONFIG_SELECTDICTIONARY};
    char st=-1;
    CannaContext_t* cx;
    uint16_t dialog_type = Req2(ch->Data.adr);
    REGISTERWORDA reg;

    VERBOSE(DBG("dialog type code %d\n",dialog_type));

    //ImmConfigureIMEhwndϥХ륳ƥȤΤΤȤȤˤ롣
    reg.lpReading = reg.lpWord = NULL;
    cx = Context.adr;

    if(dialog_type<3 && ImmConfigureIME(GetKeyboardLayout(0),cx->Win,modes[dialog_type],&reg)){
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*
  fdäƤ륳ƥȤ֤
  ׵ᡧtype1
  type7
	i16	ƥȤο
	L16	ƥȤ
*/
bool wm_wime_list_context(CannaHeader* ch,int fd)
{
    typedef struct {
	unsigned ser_num;
	int16_t cxn;
    } cxs;
    int qs_comp(const void* a0,const void* b0){
	const cxs *a = (const cxs*)a0, *b = (const cxs*)b0;
	return a->ser_num<b->ser_num ? -1:(a->ser_num>b->ser_num);
    }

    extern Array Context; 
    const CannaContext_t *cp;
    Array lst;
    cxs c,*lp;
    int n;
    int16_t *np;

    /* fdȤäƤ륳ƥȤ򽸤 */
    ArNew(&lst,sizeof(cxs),NULL);
    for(n=0,cp=Context.adr; n<Context.using; ++n,++cp){
	if(cp->Win!=NULL && cp->Connection==fd){
	    c.ser_num = cp->SerialNum;
	    c.cxn = n;
	    ArAdd(&lst,&c);
	}
    }

    /* ƥȤˤ(cxs񤭤) */
    qsort(lst.adr,lst.using,lst.blocksize,qs_comp);
    for(n=0,lp=lst.adr,np=lst.adr; n<lst.using; ++n,++lp,++np)
	*np = Swap2(lp->cxn);

    bool st = Reply7(ch->Major,ch->Minor,lst.using,lst.adr,lst.using*2);
    ArDelete(&lst);
    return st;
}

//cannaβۥwindowsβۥ
uint16_t cannavk_to_winvk(unsigned char ck,HKL kl)
{
    #define ST_SHIFT 0x100
    uint16_t wk;

    switch(ck){
    case CANNA_KEY_Up:		wk = VK_UP; break;
    case CANNA_KEY_Left:	wk = VK_LEFT; break;
    case CANNA_KEY_Right:	wk = VK_RIGHT; break;
    case CANNA_KEY_Down:	wk = VK_DOWN; break;
    case CANNA_KEY_Insert:	wk = VK_INSERT; break;
    case CANNA_KEY_PageDown:	wk = VK_NEXT; break;
    case CANNA_KEY_PageUp:	wk = VK_PRIOR; break;
    case CANNA_KEY_Home:	wk = VK_HOME; break;
    case CANNA_KEY_End:		wk = VK_END; break;
    case CANNA_KEY_Shift_Up:	wk = VK_UP|ST_SHIFT; break;
    case CANNA_KEY_Shift_Left:	wk = VK_LEFT|ST_SHIFT; break;
    case CANNA_KEY_Shift_Right:	wk = VK_RIGHT|ST_SHIFT; break;
    case CANNA_KEY_Shift_Down:	wk = VK_DOWN|ST_SHIFT; break;
    case CANNA_KEY_Cntrl_Up:	wk = VK_UP|ST_SHIFT; break;
    case CANNA_KEY_Cntrl_Left:	wk = VK_LEFT|ST_SHIFT; break;
    case CANNA_KEY_Cntrl_Right:	wk = VK_RIGHT|ST_SHIFT; break;
    case CANNA_KEY_Cntrl_Down:	wk = VK_DOWN|ST_SHIFT; break;
    case CANNA_KEY_Shift_Space:	wk = VK_SPACE|ST_SHIFT; break;
    case CANNA_KEY_F1:		wk = VK_F1 ; break;
    case CANNA_KEY_F2:		wk = VK_F2 ; break;
    case CANNA_KEY_F3:		wk = VK_F3 ; break;
    case CANNA_KEY_F4:		wk = VK_F4 ; break;
    case CANNA_KEY_F5:		wk = VK_F5 ; break;
    case CANNA_KEY_F6:		wk = VK_F6 ; break;
    case CANNA_KEY_F7:		wk = VK_F7 ; break;
    case CANNA_KEY_F8:		wk = VK_F8 ; break;
    case CANNA_KEY_F9:		wk = VK_F9 ; break;
    case CANNA_KEY_F10:		wk = VK_F10 ; break;
    case CANNA_KEY_PF1:		wk = VK_F1|ST_SHIFT ; break;
    case CANNA_KEY_PF2:		wk = VK_F2|ST_SHIFT ; break;
    case CANNA_KEY_PF3:		wk = VK_F3|ST_SHIFT ; break;
    case CANNA_KEY_PF4:		wk = VK_F4|ST_SHIFT ; break;
    case CANNA_KEY_PF5:		wk = VK_F5|ST_SHIFT ; break;
    case CANNA_KEY_PF6:		wk = VK_F6|ST_SHIFT ; break;
    case CANNA_KEY_PF7:		wk = VK_F7|ST_SHIFT ; break;
    case CANNA_KEY_PF8:		wk = VK_F8|ST_SHIFT ; break;
    case CANNA_KEY_PF9:		wk = VK_F9|ST_SHIFT ; break;
    case CANNA_KEY_PF10:	wk = VK_F10|ST_SHIFT ; break;
    case CANNA_KEY_HIRAGANA:	//ؤʬʤ
    case CANNA_KEY_KATAKANA:
    case CANNA_KEY_HANKAKUZENKAKU:
    case CANNA_KEY_EISU:
    default:
	wk = VkKeyScanEx(ck,kl);
    }
    VERBOSE(DBG("%hhx --> %hx\n",ck,wk));
    return wk;
}

/*
  ׵ᡧtype5
	i16=ƥֹ
	c16=(Ȥʤ)
	i32=ʸ
  type11
	int	ơ -1=顼,0=,1=ime˴طʤ
	int	륨ȿžʬΥեå(ʸ)
	int	ȿžʬʸ
	s8	륨ʸ(eucjp)
*/
bool wm_wime_send_char(CannaHeader* ch,int fd)
{
    int16_t cxn;
    uint16_t dum;
    int32_t chr;
    CannaContext_t *cx;
    Array scs[CS_MAX];
    int target_offset=0,target_len=0,ret=-1;

    Req5(ch->Data.adr,&cxn,&dum,&chr);
    VERBOSE(DBG("context=%hd, char=0x%x\n",cxn,chr));
    CompNew(scs);
    if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	HIMC imc = ImmGetContext(cx->Win);
	HKL kl = GetKeyboardLayout(0);
	INPUTCONTEXT *ic = (INPUTCONTEXT*)ImmLockIMC(imc);

	if(proc_key_vk(cannavk_to_winvk((unsigned char)chr,kl),(char)chr,cx->Win,kl)){
	    StoreComp(scs,imc,0,-1,EN_STR|EN_STRCL);
	    wstr_add_wc(&scs[CS_STR],0);
	    int cl = GetAttrCl(imc,ATTR_TARGET_CONVERTED,cx);
	    if(cl >= 0){
		int *target_pos = ArElem(&scs[CS_STRCL],cl);
		target_offset = *target_pos;
		target_len = *(target_pos+1) - *target_pos;
	    }
	    ret = 0;

	    ImmUnlockIMCC(ic->hCompStr);
	    ImmUnlockIMC(imc);
	    DbgComp(imc,__FUNCTION__);
	    ImmReleaseContext(cx->Win,imc);

	    /* 'a'(0x61)0xff41('A')ˤʤäƤΤǾʸľ
	       ('A'ϤȤ̤asciiɤäƤ) */
	    for(uint16_t *p=scs[CS_STR].adr; *p!=0; ++p)
		if(*p>=0xff00+'A' && *p<=0xff00+'Z')
		    *p ^= 0xff20; //+=0x100+'a'-'A';
	    WcToMb(scs[CS_STR].adr,-1,scs[CS_STR].adr,-1);
	    ConvCode(scs[CS_STR].adr,scs[CS_STR].adr,Sj2Ej);
	}else
	    ret = 1;
    }
    bool st = Reply11(ch->Major,ch->Minor,ret,target_offset,target_len,scs[CS_STR].adr);
    CompDelete(scs);
    return st;
}
