#ifndef WIME_UT_H
#define WIME_UT_H

#include <stdint.h>
#include "lib.h"

#define DBG(fmt,...) printf("%s:" fmt,__FUNCTION__, ## __VA_ARGS__)
#define DBGT(fmt,...) printf("\t" fmt, ## __VA_ARGS__)
#define DBGP printf
#define DBGD(p,n) Dump1(" 0x%02x",p,n,1)

#define VERBOSE(x) do if(Verbose){x;} while(0)

extern int Verbose;

int WcLen(const uint16_t* s);
uint16_t* WcChr(uint16_t* s,uint16_t c);
uint16_t* WcCpy(uint16_t* dst,const uint16_t* src);
uint16_t* StrListNthWc(uint16_t* s,int nmax,int n);
char* ToMb(char *dst,const uint16_t *src);
int ToWcLe(uint16_t* dest,const char* src);

uint16_t* Swap2p(void *x,int dist);
uint16_t Swap2(uint16_t x);
uint16_t Swap2c(const void *x);
uint32_t Swap4(uint32_t x);
uint32_t Swap4c(const void *x);
int* RevInt(int* x);

Array* wstr_add_nwcs(Array* s,const uint16_t *cs,int len);
Array* wstr_add_wc(Array* s,uint16_t c);
Array* wstr_add_wcs(Array* s,const uint16_t *cs);
Array* wstr_add_wstr(Array* s,const Array* p);
Array* wstr_add_sj2ej_n(Array *ws,char **sjis,int len,int le);
Array* wstr_add_sj2ej(Array *s,char *sjis,int le);
Array* wstr_add_zen2han_ej(Array *s,uint16_t *h);
Array* wstr_hira2kata_ej(Array *s);

char *Sj2Ej(char *ej,char **sj);
char *Ej2Sj(char *sj,char **ej);
char *ConvCode(char *dst,char *src,char* (*cnv)(char*,char**));
void Dump1(char *fmt,void *adr,int num,int cr);
void Dump2(char *fmt,void *adr,int num,int cr);
void Dump2le(char *fmt,void *adr,int num,int cr);
void Dump4(char *fmt,void *adr,int num,int cr);
uint16_t* DumpList2(uint16_t *ws,int nl);
int CharLengthSj(char *s,int n);
int SjHan2Zen(char *dst,char *src,int ssz,unsigned char opt,int syn);
char *ForwardSj(char *sj,int n);
char *ForwardEj(char *ej,int n);
int SjStrHan2Zen(char *dst,char *src,int ssz,unsigned char opt,int syn,int len);
int EjZen2Han(char *dst,char *src);
void StrEjZen2SjHan(char *s,char *e);
char* Zen2Roman(char* dest,const char* ej);

#endif
