#include <stdlib.h>
#include <string.h>
#include "lib.h"

#define DEFAULT_WSPAGESIZE 128

Array* ArNew(Array* ws,int bs,void (*ct)(void*))
{
    ws->adr = NULL;
    ws->blocksize = bs;
    ws->using = ws->reserve = 0;
    ws->pagesize = DEFAULT_WSPAGESIZE;
    ws->constructor = ct;
    return ws;
}

void ArDelete(Array* ws)
{
    if(!ws->adr)
	free(ws->adr);
    ArNew(ws,ws->blocksize,ws->constructor);
}

Array* ArClear(Array* ws)
{
    ws->using = 0;
    return ws;
}

/*
  nĳݤ롣
  ݤǡusingѹʤ
  ɲóݤconstructorƤФ롣
*/
Array* ArReserve(Array* ws,int count)
{
    if(count > ws->reserve){
	ws->adr = realloc(ws->adr,(ws->reserve=(count/ws->pagesize+1)*ws->pagesize)*ws->blocksize);
    }
    if(ws->constructor != NULL){
	int n;
	char *p;
	for(n=ws->using,p=ArElem(ws,n); n<ws->reserve; ++n,p+=ws->blocksize)
	    ws->constructor(p);
    }
    return ws;
}

//nĳݤ
//Ƭ֤
void* ArAlloc(Array* a,int n)
{
    ArReserve(a,n);
    a->using = n;
    return a->adr;
}

//nɲûѤ
//ʬƬ֤
void* ArExpand(Array* ws,int n)
{
    void *p;
    ArReserve(ws,ws->using+n);
    p = ArElem(ws,ws->using);
    ws->using += n;
    return p;
}

void* ArElem(Array* ws,int n)
{
    return (char*)(ws->adr)+n*ws->blocksize;
}

int ArFind(const Array* ws,const void* p)
{
    int n;
    char* src;

    for(src=ws->adr,n=0; n<ws->using; src+=ws->blocksize,++n){
	if(memcmp(src,p,ws->blocksize) == 0)
	    break;
    }
    return n<ws->using ? n : -1;
}

Array* ArRemove(Array* ws,int pos)
{
    if(pos >= 0){
	char *ad = ArElem(ws,pos);
	memcpy(ad,ad+ws->blocksize,(ws->using-pos-1)*ws->blocksize);
	-- ws->using;
    }
    return ws;
}

//eq(val,ǥɥ쥹)ˤʤǤֹ֤
//ĤʤȤ-1֤
int ArFindIf(const Array* a,int start,int (*eq)(const void*,const void*),const void* val)
{
    int st=-1;
    for(char *ep=a->adr; start<a->using; ++start,ep+=a->blocksize)
	if(eq(val,ep)){
	    st = start;
	    break;
	}
    return st;
}

//eq(val,ǥɥ쥹)ˤʤǤ֤
//ĤʤȤArExpandƤӽФ
void* ArFindElemIf(Array* a,int (*eq)(const void*,const void*),const void* val)
{
    int n = ArFindIf(a,0,eq,val);
    return n<0 ? ArExpand(a,1) : ArElem(a,n);
}

void ArForEach(Array* a,AR_FOREACH func)
{
    char* p = a->adr;
    for(int n=0; n<a->using; ++n,p+=a->blocksize)
	func(p);
}

//nʸɲ
Array* ArAddN(Array* a,const void *p,int n)
{
    memcpy(ArExpand(a,n),p,n*a->blocksize);
    return a;
}

Array* ArAdd(Array* a,const void *p)
{
    return ArAddN(a,p,1);
}

Array* ArAdd1(Array* ws,char c)
{
    *(char*)ArExpand(ws,1) = c;
    return ws;
}

//dst֤
Array* ArCopy(Array* dst,const Array* src)
{
    dst->reserve = (dst->reserve*dst->blocksize)/src->blocksize;
    dst->blocksize = src->blocksize;
    dst->pagesize = src->pagesize;
    dst->constructor = src->constructor;
    dst->using = 0;
    memcpy(ArAlloc(dst,src->using),src->adr,src->using*src->blocksize);
    return dst;
}

Array* ArInsert(Array* a,int pos,int count,const void* p)
{
    ArExpand(a,count);
    memmove(ArElem(a,pos+count),ArElem(a,pos),(a->using-pos)*a->blocksize);
    memcpy(ArElem(a,pos),p,count*a->blocksize);
    return a;
}
