#ifndef WIME_LIB_H
#define WIME_LIB_H

typedef struct{
    void *adr;
    int blocksize;
    int using;
    int reserve;
    int pagesize;
    void (*constructor)(void*);
} Array;

Array* ArNew(Array* ws,int bs,void (*ct)(void*));
void ArDelete(Array* ws);
Array* ArClear(Array* ws);
Array* ArReserve(Array* ws,int count);
void* ArExpand(Array* ws,int n);
Array* ArAddN(Array* a,const void *p,int n);
Array* ArAdd(Array* a,const void *p);
Array* ArAdd1(Array* ws,char c);
int ArFind(const Array* ws,const void* p);
Array* ArRemove(Array* ws,int pos);
void* ArElem(Array* ws,int n);
int ArFindIf(const Array* a,int start,int (*eq)(const void*,const void*),const void* val);
void* ArFindElemIf(Array* a,int (*eq)(const void*,const void*),const void* val);
void* ArAlloc(Array* a,int n);
Array* ArCopy(Array* dst,const Array* src);
Array* ArInsert(Array* a,int pos,int count,const void* p);

typedef void (*AR_FOREACH)(void*);
void ArForEach(Array* a,AR_FOREACH func);

#endif
