#ifndef WIME_PKT_H
#define WIME_PKT_H

#include <stdint.h>

typedef struct{
    int8_t major;
    int8_t minor;
    uint16_t len;
}__attribute__((packed)) Header;

//--------------------------------------------

typedef struct{
    int32_t init;
    int32_t len;
    char info[0];
}__attribute__((packed)) Snd0_t;

typedef Header Snd1_t;

typedef struct{
    Header h;
    int16_t cxn;
}__attribute__((packed)) Snd2_t;

typedef struct{
    Header h;
    int16_t cxn;
    uint16_t sz;
    int32_t mode;
}__attribute__((packed)) Snd5_t;

typedef struct{
    Header h;
    int16_t cxn;
    int16_t cl;
    uint16_t str[0];
}__attribute__((packed)) Snd11_t;

typedef struct{
    Header h;
    char str[0];
}__attribute__((packed)) Snd17_t;

//--------------------------------------------

typedef struct{
    uint16_t minor;
    int16_t cxn;
}__attribute__((packed)) Rcv0_t;

typedef struct{
    Header h;
    char num;
}__attribute__((packed)) Rcv2_t;

typedef struct{
    Header h;
    char st;
    uint16_t str[0];
}__attribute__((packed)) Rcv3_t;

typedef struct{
    Header h;
    int16_t cxn;
}__attribute__((packed)) Rcv5_t;

typedef struct{
    Header h;
    int16_t p1;
    char p2[0];
}__attribute__((packed)) Rcv6_t;

typedef struct{
    Header h;
    int16_t p1;
    uint16_t s[0];
}__attribute__((packed)) Rcv7_t;

typedef struct{
    Header h;
    int pi[3];
    char p4[0];
}__attribute__((packed)) Rcv11_t;

#endif
